# coding: utf-8

"""
    Carbon

    Connect external data to LLMs, no matter the source.

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from carbon import schemas  # noqa: F401


class ListDataSourceItemsRequest(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "data_source_id",
        }
        
        class properties:
            data_source_id = schemas.IntSchema
            
            
            class parent_id(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'parent_id':
                    return super().__new__(
                        cls,
                        *args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def filters() -> typing.Type['ListItemsFiltersNullable']:
                return ListItemsFiltersNullable
        
            @staticmethod
            def pagination() -> typing.Type['Pagination']:
                return Pagination
        
            @staticmethod
            def order_by() -> typing.Type['ExternalSourceItemsOrderBy']:
                return ExternalSourceItemsOrderBy
        
            @staticmethod
            def order_dir() -> typing.Type['OrderDirV2']:
                return OrderDirV2
            __annotations__ = {
                "data_source_id": data_source_id,
                "parent_id": parent_id,
                "filters": filters,
                "pagination": pagination,
                "order_by": order_by,
                "order_dir": order_dir,
            }
    
    data_source_id: MetaOapg.properties.data_source_id
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["data_source_id"]) -> MetaOapg.properties.data_source_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["parent_id"]) -> MetaOapg.properties.parent_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["filters"]) -> 'ListItemsFiltersNullable': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["pagination"]) -> 'Pagination': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["order_by"]) -> 'ExternalSourceItemsOrderBy': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["order_dir"]) -> 'OrderDirV2': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["data_source_id", "parent_id", "filters", "pagination", "order_by", "order_dir", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["data_source_id"]) -> MetaOapg.properties.data_source_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["parent_id"]) -> typing.Union[MetaOapg.properties.parent_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["filters"]) -> typing.Union['ListItemsFiltersNullable', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["pagination"]) -> typing.Union['Pagination', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["order_by"]) -> typing.Union['ExternalSourceItemsOrderBy', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["order_dir"]) -> typing.Union['OrderDirV2', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["data_source_id", "parent_id", "filters", "pagination", "order_by", "order_dir", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        data_source_id: typing.Union[MetaOapg.properties.data_source_id, decimal.Decimal, int, ],
        parent_id: typing.Union[MetaOapg.properties.parent_id, None, str, schemas.Unset] = schemas.unset,
        filters: typing.Union['ListItemsFiltersNullable', schemas.Unset] = schemas.unset,
        pagination: typing.Union['Pagination', schemas.Unset] = schemas.unset,
        order_by: typing.Union['ExternalSourceItemsOrderBy', schemas.Unset] = schemas.unset,
        order_dir: typing.Union['OrderDirV2', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ListDataSourceItemsRequest':
        return super().__new__(
            cls,
            *args,
            data_source_id=data_source_id,
            parent_id=parent_id,
            filters=filters,
            pagination=pagination,
            order_by=order_by,
            order_dir=order_dir,
            _configuration=_configuration,
            **kwargs,
        )

from carbon.model.external_source_items_order_by import ExternalSourceItemsOrderBy
from carbon.model.list_items_filters_nullable import ListItemsFiltersNullable
from carbon.model.order_dir_v2 import OrderDirV2
from carbon.model.pagination import Pagination
