# coding: utf-8

"""
    Carbon

    Connect external data to LLMs, no matter the source.

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from carbon import schemas  # noqa: F401


class PullRequestsInput(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "repository",
            "data_source_id",
        }
        
        class properties:
            data_source_id = schemas.IntSchema
            repository = schemas.StrSchema
            include_remote_data = schemas.BoolSchema
            page = schemas.IntSchema
            
            
            class page_size(
                schemas.IntSchema
            ):
                pass
            
            
            class next_cursor(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'next_cursor':
                    return super().__new__(
                        cls,
                        *args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def filters() -> typing.Type['PullRequestFilters']:
                return PullRequestFilters
        
            @staticmethod
            def order_by() -> typing.Type['PROrderBy']:
                return PROrderBy
        
            @staticmethod
            def order_dir() -> typing.Type['OrderDirV2Nullable']:
                return OrderDirV2Nullable
            __annotations__ = {
                "data_source_id": data_source_id,
                "repository": repository,
                "include_remote_data": include_remote_data,
                "page": page,
                "page_size": page_size,
                "next_cursor": next_cursor,
                "filters": filters,
                "order_by": order_by,
                "order_dir": order_dir,
            }
    
    repository: MetaOapg.properties.repository
    data_source_id: MetaOapg.properties.data_source_id
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["data_source_id"]) -> MetaOapg.properties.data_source_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["repository"]) -> MetaOapg.properties.repository: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["include_remote_data"]) -> MetaOapg.properties.include_remote_data: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["page"]) -> MetaOapg.properties.page: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["page_size"]) -> MetaOapg.properties.page_size: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["next_cursor"]) -> MetaOapg.properties.next_cursor: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["filters"]) -> 'PullRequestFilters': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["order_by"]) -> 'PROrderBy': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["order_dir"]) -> 'OrderDirV2Nullable': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["data_source_id", "repository", "include_remote_data", "page", "page_size", "next_cursor", "filters", "order_by", "order_dir", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["data_source_id"]) -> MetaOapg.properties.data_source_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["repository"]) -> MetaOapg.properties.repository: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["include_remote_data"]) -> typing.Union[MetaOapg.properties.include_remote_data, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["page"]) -> typing.Union[MetaOapg.properties.page, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["page_size"]) -> typing.Union[MetaOapg.properties.page_size, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["next_cursor"]) -> typing.Union[MetaOapg.properties.next_cursor, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["filters"]) -> typing.Union['PullRequestFilters', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["order_by"]) -> typing.Union['PROrderBy', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["order_dir"]) -> typing.Union['OrderDirV2Nullable', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["data_source_id", "repository", "include_remote_data", "page", "page_size", "next_cursor", "filters", "order_by", "order_dir", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        repository: typing.Union[MetaOapg.properties.repository, str, ],
        data_source_id: typing.Union[MetaOapg.properties.data_source_id, decimal.Decimal, int, ],
        include_remote_data: typing.Union[MetaOapg.properties.include_remote_data, bool, schemas.Unset] = schemas.unset,
        page: typing.Union[MetaOapg.properties.page, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        page_size: typing.Union[MetaOapg.properties.page_size, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        next_cursor: typing.Union[MetaOapg.properties.next_cursor, None, str, schemas.Unset] = schemas.unset,
        filters: typing.Union['PullRequestFilters', schemas.Unset] = schemas.unset,
        order_by: typing.Union['PROrderBy', schemas.Unset] = schemas.unset,
        order_dir: typing.Union['OrderDirV2Nullable', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'PullRequestsInput':
        return super().__new__(
            cls,
            *args,
            repository=repository,
            data_source_id=data_source_id,
            include_remote_data=include_remote_data,
            page=page,
            page_size=page_size,
            next_cursor=next_cursor,
            filters=filters,
            order_by=order_by,
            order_dir=order_dir,
            _configuration=_configuration,
            **kwargs,
        )

from carbon.model.order_dir_v2_nullable import OrderDirV2Nullable
from carbon.model.pr_order_by import PROrderBy
from carbon.model.pull_request_filters import PullRequestFilters
