# coding: utf-8

"""
    Carbon

    Connect external data to LLMs, no matter the source.

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING
from pydantic import BaseModel, Field, RootModel, ConfigDict

from carbon.pydantic.cold_storage_props import ColdStorageProps
from carbon.pydantic.embedding_generators_nullable import EmbeddingGeneratorsNullable

class RawTextInput(BaseModel):
    contents: str = Field(alias='contents')

    name: typing.Optional[typing.Optional[str]] = Field(None, alias='name')

    chunk_size: typing.Optional[typing.Optional[int]] = Field(None, alias='chunk_size')

    chunk_overlap: typing.Optional[typing.Optional[int]] = Field(None, alias='chunk_overlap')

    skip_embedding_generation: typing.Optional[bool] = Field(None, alias='skip_embedding_generation')

    overwrite_file_id: typing.Optional[typing.Optional[int]] = Field(None, alias='overwrite_file_id')

    embedding_model: typing.Optional[EmbeddingGeneratorsNullable] = Field(None, alias='embedding_model')

    generate_sparse_vectors: typing.Optional[typing.Optional[bool]] = Field(None, alias='generate_sparse_vectors')

    cold_storage_params: typing.Optional[ColdStorageProps] = Field(None, alias='cold_storage_params')

    # If this flag is enabled, the file will be chunked and stored with Carbon,         but no embeddings will be generated. This overrides the skip_embedding_generation flag.
    generate_chunks_only: typing.Optional[bool] = Field(None, alias='generate_chunks_only')

    # If this flag is enabled, the file will be stored with Carbon, but no processing will be done.
    store_file_only: typing.Optional[bool] = Field(None, alias='store_file_only')

    model_config = ConfigDict(
        protected_namespaces=(),
        arbitrary_types_allowed=True
    )
