# coding: utf-8

"""
    Carbon

    Connect external data to LLMs, no matter the source.

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING

from carbon.type.issue_pr_nullable import IssuePRNullable
from carbon.type.label import Label
from carbon.type.pr_state import PRState
from carbon.type.user import User
from carbon.type.user_nullable import UserNullable

class RequiredIssue(TypedDict):
    title: str

    id: int

    url: str

    html_url: str

    number: int

    user: User

    labels: typing.List[Label]

    state: PRState

    locked: bool

    num_comments: int

    created_at: str

    updated_at: str

    closed_at: typing.Optional[str]

    draft: bool

    pull_request: typing.Optional[IssuePRNullable]

    body: str

    closed_by: typing.Optional[UserNullable]

class OptionalIssue(TypedDict, total=False):
    pass

class Issue(RequiredIssue, OptionalIssue):
    pass
